// used to ensure that dashboardpanel.js is loaded into the child window before
// the parent tries to call functions in it. there really should be a way
// for a scripts is loaded event to be passed to a window...


// global pref service
var gPref = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefBranch);
// used to set/clear timeouts of the popup opening/closing
var gDashboardPopupTimout;
const nsIUpdateService = Components.interfaces.nsIUpdateService;
const ONE_DAY_IN_SECONDS = 86400; 

var gDashboardHiddenTimestamp = 0;
var gDashboardBundle = document.getElementById('dashboardBundle');

if (!gPrefService) {
	var gPrefService = Components.classes["@mozilla.org/preferences-service;1"]
	                         .getService(Components.interfaces.nsIPrefBranch);
}
var gObserver;
var gFadeTimer;

var dashboard = window.arguments[0].dashboard;
var gBrowser = window.arguments[0].gBrowser;
var threatsQueue = window.arguments[0].threatsQueue;
var sitecontrols = window.arguments[0].sitecontrols;
var balloonhelp = window.arguments[0].balloonhelp;
var spyWareScanner = window.arguments[0].spyWareScanner;
var gEffectType = window.arguments[0].effectType;

dashboard.mDashboardWindowLoaded = false;

var DashboardUIController = {
	statusbarPanel : null,
	statusbarLabel : null,
	statusbarThreatIcon: null,
		
	init: function() {
		/* reference to the DOM elements in the parent window */
		this.statusbarPanel = window.opener.document.getElementById('securityDashboard');	
		this.statusbarLabel = window.opener.document.getElementById('securityDashboardLabel');
		this.statusbarThreatIcon = window.opener.document.getElementById('currThreatItemIcon');
	},	
}

function getCurrentWindowID() {
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var enumerator = windowManagerInterface.getEnumerator(null);
	var numWindows = 1;
	while (enumerator.hasMoreElements()) {
		enumerator.getNext();
		numWindows++;
	}
	return numWindows;	
}


function DisplayAllPanels() {
	var panels = GetDashboardPanels();
	for (var i=0; i < panels.length; i++) {
		panels[i].removeAttribute('hidden');
	}
}

/*******************************************************************/
/* RemoveAutoExposedWarnings()
/* Removes any autoexposed warnings			
/*********************************************************************/
function RemoveAutoExposedWarnings() {
	var panels = GetDashboardPanels();
	for (var i=0; i< panels.length; i++) {
		if (panels[i].hasAttribute('warningAutoExposed'))
			panels[i].removeAttribute('warningAutoExposed');
	}
}


/*******************************************************************/
/* SetPanelAutoExposedWarnings()
/* Sets the Panel with any auto exposed warnings								
/*********************************************************************/
function SetPanelAutoExposedWarnings() {
	// iterate through the threats queue and set autoexposed warnings
	// on teh appropriate panels
	
	for (var i=0; i < threatsQueue.mThreats.length; i++) {
		var lastAutoexposed;
		if (threatsQueue.mThreats[i] == "red") {
			switch (i) {
					case dashboard.kSpyware:
						document.getElementById('currentSiteStatus').setAttribute('warningAutoExposed', true);
						document.getElementById('sdSpyWatch').setAttribute('warningAutoExposed', true);
						lastAutoexposed = "spyware";
					break;
								
					case dashboard.kPhishing:
						document.getElementById('currentSiteStatus').setAttribute('warningAutoExposed', true);
						document.getElementById('sdIdentityGuard').setAttribute('warningAutoExposed', true);
						lastAutoexposed = "phishing";
					break;
									
					case dashboard.kBlackListUpdateError:
						document.getElementById('sdSpyWatch').setAttribute('warningAutoExposed', true);
						document.getElementById('sdIdentityGuard').setAttribute('warningAutoExposed', true);
						lastAutoexposed = "blacklist-update-error";
					break;
								
					case dashboard.kCriticalUpdate: 
						document.getElementById('sdBrowserUpdates').setAttribute('warningAutoExposed', true);
						lastAutoexposed = "critical-update-available";
					break;
				}
		}
		
	}			
}

function StartScroll() {
	if (dashboard.shouldAutoExpose() && gEffectType=="fade") {
		FadeIn();
	} else if (gEffectType=="scroll"){
		ScrollUp();
	} else if (gEffectType=="none") {
		DisplayNormal();
	}
}

var gScrollUpTimoutTime = 30;

function ScrollUp(currentIndex) {
	if (!currentIndex)
		currentIndex = 0;
	
	if (currentIndex > 5) {
		gScrollUpTimoutTime = 30;
		return;
	}
	var panels = GetDashboardPanels();
	panels[currentIndex].removeAttribute("hidden");
	RepositionDashboard();
	currentIndex++;
	setTimeout('ScrollUp(' + currentIndex + ')', gScrollUpTimoutTime);
}


function ScrollDown(currentIndex) {
	if (dashboard.mDashboardWindow == null)
		return;
		
	if (currentIndex < 0) {
		// dereference the handle to the window
		dashboard.mDashboardWindow = null;
		// ugghh.. need to this when the user intentionally closes the dashboard. If
		// the mainwindow in minimized, we this attribute isn't removed, so thats
		// how we can tell if the dashboard was open at time of the minimize event
		var dbChromeRegion = window.opener.document.getElementById('securityDashboard');
		if (dbChromeRegion)
			dbChromeRegion.removeAttribute('isOpen');
			
		window.close();
		return;
	}	
	if (!currentIndex && currentIndex != 0)
		currentIndex = 4;
	
	var panels = GetDashboardPanels();
	panels[currentIndex].setAttribute('hidden', true);
	RepositionDashboard();	
	currentIndex--;
	setTimeout('ScrollDown(' + currentIndex + ')', 30);
}

function DisplayNormal() {
	DisplayAllPanels();
}


function FadeIn(aOpacity) {	
	var container = document.getElementById('dashboardContainer');
	if (!aOpacity) {
		aOpacity = 0;
		dashboard.mDashboardWindow.setTransparency(1);
		DisplayAllPanels();
		ToggleAutoexposeCheckboxVisibility();
		SetDashShouldClose();
	}
	if (aOpacity >= 255) {
		// set timer to close it
		if (container.hasAttribute('shouldClose')) {
			container.setAttribute('opacity', aOpacity);
			clearTimeout(gFadeTimer);
			gFadeTimer = setTimeout('FadeOut()', dashboard.THREAT_OPEN_DASHBOARD_INTERVAL);
		}
		return;
	}	
	aOpacity = aOpacity + 15;
	dashboard.mDashboardWindow.setTransparency(aOpacity);
	RepositionDashboard();
	gFadeTimer = setTimeout('FadeIn(' + aOpacity + ')', 100);
}

function FadeOut(aOpacity) {
	var container = document.getElementById('dashboardContainer');	
	if (dashboard.mDashboardWindow == null)
		return;
	
	if (!container.hasAttribute('shouldClose')) {
		clearTimeout(gFadeTimer);
		dashboard.mDashboardWindow.setTransparency(255);
		return;
	}
		
	if (!aOpacity && aOpacity != 0) {
		aOpacity  = container.getAttribute('opacity');
	}
	
	if (aOpacity < 5) {
		var secDash = window.opener.document.getElementById('securityDashboard');
		if (secDash) {
			secDash.removeAttribute('isOpen');
		}
		clearTimeout(gFadeTimer);
		window.close();
		dashboard.mDashboardWindow = null;
		return;
	}	
	
	aOpacity = aOpacity - 15;
	dashboard.mDashboardWindow.setTransparency(aOpacity);
	RepositionDashboard();
	gFadeTimer = setTimeout('FadeOut(' + aOpacity + ')', 100);
}

function SetFullyOpaque() {
	clearTimeout(gFadeTimer);
	clearTimeout(dashboard.mDailyExposureCloseTimer);
	container = document.getElementById('dashboardContainer');
	container.removeAttribute('shouldClose');
	container.setAttribute('opacity', '255');
	dashboard.mDashboardWindow.setTransparency(255);
}

function RepositionDashboard() {
	window.sizeToContent();
	var anchorNode = window.opener.document.getElementById('securityDashboard');
	var dashboardContainer = document.getElementById('dashboardContainer');
	dashboard.mDashboardWindow.moveTo(anchorNode.boxObject.screenX, anchorNode.boxObject.screenY - dashboardContainer.boxObject.height);
}

function HidePanels() {
	for (var i=0; i < 5; i++)
		dashboard.mPanels[i].setAttribute('hidden', true);	
}

function HideDashboard() {
	// auto hide the dashboard after X seconds if the user hasn't clicked on it and the current state
	// has no critical threats
	// when hiding the dashboard, if it was an autoexposed invocaton, remove the attribute
	if (dashboard.mDashboardPopup.hasAttribute("isAutoexposed"))
		dashboard.mDashboardPopup.removeAttribute("isAutoexposed");
	
	if (!dashboard.mDashboardPopup.hasAttribute('keepOpen')) {
		FadeElement(1, -1);
	}
}

function EnsureExposedPanelShouldClose() {
	var container = document.getElementById('dashboardContainer');
	if (container) {
		if (container.hasAttribute('shouldClose'))
			ScrollDown();
	}
}

function SetDashShouldClose() {
	document.getElementById('dashboardContainer').setAttribute('shouldClose', true);
}


function FadeElement(aFactor, aDirection, aNodeId) {
	
	if (aNodeId == "" || aNodeId == null)
		aNodeId = 'dashboardContainer';
	
	var elem = document.getElementById(aNodeId);
		if (!elem) return;
	
	// dont fade if the dashboard popup is not open or doesnt exist
	var dashboardPopup = document.getElementById('securityDashboardPopup');
	if (!dashboardPopup || !dashboardPopup.hasAttribute('open') || aFactor == 0.65) {
		elem.setAttribute("style", "-moz-opacity: " + 0.9 + ";");
		return;
	}
	
	// fade in
	if (aDirection > 0) {
		if (aFactor >= 1) {
			elem.removeAttribute('style');
			return;
		}
		aFactor= aFactor + dashboard.mOpacityIncrement;
	}	
	// fade out
	else {
		if (!dashboard.mDashboardPopup.hasAttribute("open"))
			return;
		if (aFactor <= dashboard.mOpacityIncrement) {
			dashboard.mDashboardPopup.hidePopup();
			elem.removeAttribute('style');
			return;
		}
		aFactor= aFactor - dashboard.mOpacityIncrement;
	}
	var styleString = "-moz-opacity: " + aFactor + ";";
	elem.setAttribute('style', styleString);
	var callFnString = "FadeElement(" + aFactor + "," + aDirection + ",'" + aNodeId + "')";
	
	// call the timeout
	setTimeout(callFnString, 12);

}


function ToggleExpandButton(aTarget) {	
	var aTarget = aTarget.parentNode.parentNode.parentNode;	
	var alreadyExpanded = aTarget.getAttribute('open');
	var expandedContent = aTarget.firstChild.firstChild.nextSibling.firstChild.nextSibling;
	CollapseAllPanels();	
	if (alreadyExpanded) {
		aTarget.removeAttribute('open');
	} else {
		aTarget.setAttribute('open', true);	
		FadeElement(0, 1, expandedContent.getAttribute('id'));
	}
	RepositionDashboard();
}


/**********************************************************/
/* CollapseAllPanels() 
/* Collapses all dashboard panels
/**********************************************************/
function CollapseAllPanels() {
	var panels = GetDashboardPanels();	
	for (var i=0; i < panels.length; i++) {
		if (panels[i].hasAttribute('open'))
			panels[i].removeAttribute('open');
	}
}


/**********************************************************/
/* openSiteControlsPopup()
/* Opens the Site control popup with a particular tab
/**********************************************************/
function openSiteControlsPopup(aTabIndex) {
	if (aTabIndex == null)
		aTabIndex = 0;
	window.opener.OpenSiteTrustSettings(aTabIndex);
}


/**********************************************************/
/* UpdateSecurityDashboard()
/* Updates the inner states of each of the panels in the
/* dashboard based on the values in the dashboard object.
/**********************************************************/

function UpdateSecurityDashboard() {
	
	// remove any trust partner icons before trying to add more
	CleanTrustPartnerIcons();

	var currentURI = gBrowser.currentURI;
	var sc = sitecontrols.SCSVC;
	var site = sc.getResourceForURI(currentURI.spec);
	
	SetIDGuardPanelUI(sc);
	SetSpywatchPanelUI(sc);
	SetCurrentSiteStatusPanelUI(sc);
	SetCurrentSiteRatingsPanelUI();
	SetPopupBlockingPanelUI();
	SetBrowserUpdatePanelUI();
	
		
	// clean up any exposed warnings
	RemoveAutoExposedWarnings();
	RemoveAutoExposedMessages();
	SetPanelAutoExposedWarnings();
	SetAutoExposedUI();
	dashboard.flipToNextThreat();
	
	// resize the window if autoexposed messages require more space then
	// we originally opened with.
	RepositionDashboard();
}

function checkForUpdates()
{
  var updates = Components.classes["@mozilla.org/updates/update-service;1"]
                          .getService(Components.interfaces.nsIUpdateService);
  updates.checkForUpdates([], 0, Components.interfaces.nsIUpdateItem.TYPE_ANY, 
                          Components.interfaces.nsIUpdateService.SOURCE_EVENT_USER,
                          null);
}


function StartSilentUpdate() {
	var updates = Components.classes["@mozilla.org/updates/update-service;1"]
                          .getService(Components.interfaces.nsIUpdateService);
  updates.checkForUpdates([], 0, Components.interfaces.nsIUpdateItem.TYPE_SILENT, 
                          Components.interfaces.nsIUpdateService.SOURCE_EVENT_BACKGROUND,
                          null);                      
}


function showSpyFullScan() {
	var promptSvc = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);	
	if (!spyWareScanner.isInstalled()) {
		var msg = "A serious error has occurred, please reinstall Netscape.";
		promptSvc.alert(null,"Alert", msg);
	} else {
		try
		{
		spyWareScanner.performFullScan();
	}
	catch (e)
	{
		var msg = gDashboardBundle.getString('dashboardFullscanerrorcaption');
		promptSvc.alert(null,"Alert", msg);
	}
	}
}

function setProblemAutoExpose(aCheckbox) {
	dashboard.mAutoExposeProblem = gPref.setBoolPref('browser.securitycenter.autoexpose', aCheckbox.checked);
}

function setDailyAutoExpose(aCheckbox) {
	dashboard.mAutoExposeDaily = gPref.setBoolPref('browser.securitycenter.showdailyautoexposure', aCheckbox.checked);
}

function OpenSiteSettingsDialog() {
	var params = {gBrowser: document.getElementById('content'),
								sitecontrols: sitecontrols,
							}

	window.openDialog('chrome://browser/content/securitydashboard/siteSettings.xul', '_blank', 
										'modal,chrome,resizable=yes"', params)
}

/* Set the autoexposed warning for a panel.*/
function SetAutoExposedUI() {
	var exposedPanels = document.getElementsByAttribute('warningAutoExposed', true);
	for (var i=0; i< exposedPanels.length; i++) {
		// special case for blacklist download error, identity guard and spywatch panels have
		// unable to update blacklist errors
		
		if (threatsQueue[dashboard.kBlackListUpdateError] != null) {
			blacklistUpdateError = true;
			theWarning = dashboard.GetAutoExposedWarning(exposedPanels[i].id);
		}
		
		var theWarning = dashboard.GetAutoExposedWarning(exposedPanels[i].id);
		var targetPanel = document.getElementById(exposedPanels[i].id)
		if (targetPanel) {
			var exposedNode = targetPanel.firstChild.firstChild.nextSibling;
			var exposedMessage = document.createElement("label");
			exposedMessage.setAttribute("class", "autoexposed-text");
			exposedMessage.setAttribute("isMutable", true);
			exposedMessage.setAttribute('value', theWarning);
			exposedNode.appendChild(exposedMessage);
		}
	}	
}

function RemoveAutoExposedMessages() {
	var exposedElementLabels = document.getElementsByAttribute('class', 'autoexposed-text');
	var labelParent;
	for (var i=0; i < exposedElementLabels.length; i++) {
		labelParent = exposedElementLabels[i].parentNode;
		labelParent.removeChild(exposedElementLabels[i]);
	}
}	

function ResetSpywareUI() {
	document.getElementById('sdSpyWatch').removeAttribute('status');
	document.getElementById('sdSpyWatch').removeAttribute('noFullScan');
	document.getElementById('SpyWatchEnabledDescription').setAttribute('value', 'Enabled');
	document.getElementById('SpyWatchEnabledDescription').setAttribute('value', '');
}

function GetDashboardPanels() {
		return document.getElementsByAttribute('isPanelContainer', true);
}

/****************************************************************/
/* CleanTrustPartnerIcons()
/* Removes any trust partner icons from current site rating
/* panel, ID Theft Panel, and Spywatch Panel
/*****************************************************************/
function CleanTrustPartnerIcons() {
	// remove any trust partners before appending more to the security dashboard
	var sitePartnerContainer = document.getElementById('sdSitePartnersContainer');
	while(sitePartnerContainer.firstChild) {
			sitePartnerContainer.removeChild(sitePartnerContainer.firstChild);
	}
	
	var idGuardPartnerContainer = document.getElementById('idGuardPartnersContainer');
	while(idGuardPartnerContainer.firstChild) {
		idGuardPartnerContainer.removeChild(idGuardPartnerContainer.firstChild);
	}
	
	var spywatchPartnerContainer = document.getElementById('spywatchPartnersContainer');
	while(spywatchPartnerContainer.firstChild) {
		spywatchPartnerContainer.removeChild(spywatchPartnerContainer.firstChild);
	}
	
}

function SetIDGuardPanelUI(sc) {
	var lastUpdateString = GetLastBlackListLastUpdateString();
	document.getElementById('sdIdentityGuardLastUpdate').setAttribute('value', lastUpdateString);
	
	// case everything is peachy
	var idTheftPanel = document.getElementById('sdIdentityGuard');
	var idTheftPanelStatus = document.getElementById('IdentityGuardEnabledDescription');
	var idTheftMessage = "";
	var partnerPrefix = document.getElementById('idGuardPartnerPrefixDesc');
	var blackListRefreshMessage = document.getElementById('sdIdGuardBlacklistRefresh');
	var idGuardButton = document.getElementById('sdIdentityGuardBtn');
	
	idGuardButton.hidden = true;
	blackListRefreshMessage.hidden = true;
	partnerPrefix.setAttribute('value', gDashboardBundle.getString('dashboardBlacklistedBy'));	
	partnerPrefix.hidden = true;
	if (dashboard.mCurrentSiteWarningType == "phishing") {
		idTheftPanel.setAttribute('status', 'critical');
		idTheftPanelStatus.setAttribute('value', 'ID Theft Site');
		idTheftMessage = 'Suspected ID Theft Site';
		partnerPrefix.hidden = false;
		AddPartnerIconsToContainer('idGuardPartnersContainer', sc.SC_TRUST_PHISHLIST_IDX);
	} else if (dashboard.mBlackListDownloadError == true) {
		idTheftPanel.setAttribute('status', 'critical');
		idTheftPanelStatus.setAttribute('value', 'Error');
		idTheftMessage = 'Unable to Update Blacklist';
		blackListRefreshMessage.hidden = false;
		blackListRefreshMessage.setAttribute('value', GetNextSilentUpdateAttemptString());
		idGuardButton.hidden=false;
		idGuardButton.setAttribute('label', 'Try Again Now');
		idGuardButton.setAttribute('onclick', 'StartSilentUpdate();');
	} else if (dashboard.mBlackListUpdateTooLong == true) {
		idTheftPanel.setAttribute('status', 'warning');
		idTheftPanelStatus.setAttribute('value', 'Not Effective');
		idTheftMessage = 'Update Delay Too Long';
	} else {
		idTheftPanel.removeAttribute('status');
		idTheftPanelStatus.setAttribute('value', 'Enabled');
		idTheftMessage = 'Enabled';
	}
	
	document.getElementById('sdIdentityProtectionStatus').setAttribute('value', idTheftMessage);
}

function SetSpywatchPanelUI(sc) {
	// case everything is peachy
	var spyWatchPanel = document.getElementById('sdSpyWatch');
	var spyWatchPanelStatus = document.getElementById('SpyWatchEnabledDescription');
	var spywatchMessage = "";
	var partnerPrefix = document.getElementById('spywatchPartnerPrefixDesc');
	var blackListRefreshMessage = document.getElementById('sdSpyWatchBlacklistRefresh');
	var panelButton = document.getElementById('sdSpyWatchRunScanBtn');
	// hide trust partner prefix and next blacklist download attempt message
	partnerPrefix.hidden = true;
	blackListRefreshMessage.hidden = true;
	panelButton.hidden = true;
	var lastUpdateString;
	
	// some threat exists...
	if (dashboard.mCurrentSiteWarningType == "spyware") {
		spyWatchPanel.setAttribute('status', 'critical');
		spyWatchPanelStatus.setAttribute('value', 'Spyware Site');
		spywatchMessage = "Suspected Spyware Site";
		partnerPrefix.hidden = false;
		AddPartnerIconsToContainer('spywatchPartnersContainer', sc.SC_TRUST_SPYLIST_IDX);
	} else if (dashboard.mBlackListDownloadError == true) {
		spyWatchPanel.setAttribute('status', 'critical');
		spyWatchPanelStatus.setAttribute('value', 'Error');
		spywatchMessage = "Unable to Update Blacklist";
		blackListRefreshMessage.hidden = false;
		blackListRefreshMessage.setAttribute('value', GetNextSilentUpdateAttemptString());
		panelButton.hidden = false;
		panelButton.setAttribute('label', 'Try Again Now');
		panelButton.setAttribute('onclick', 'StartSilentUpdate();');
	} else if (dashboard.mBlackListUpdateTooLong == true) {
		spyWatchPanel.setAttribute('status', 'warning');
		spyWatchPanelStatus.setAttribute('value', 'Not Effective');
		spywatchMessage = 'Update Delay Too Long';
	} else if (dashboard.mSpyWareLastFullScan == 0) {
		spyWatchPanel.setAttribute('status', 'warning');
		spyWatchPanelStatus.setAttribute('value', 'No Full Scan');
		spywatchMessage = "Full Scan Not Yet Run";
		if (panelButton.hidden == true) {
			panelButton.hidden = false;
			panelButton.setAttribute('label', 'Run Scan...');
			panelButton.setAttribute('onclick', 'showSpyFullScan();');
		}
	} else {
		spyWatchPanel.removeAttribute('status');			
		spyWatchPanelStatus.setAttribute('value', 'Enabled');
		spywatchMessage = "Enabled";
	}		
dashboard.debug(dashboard.mSpyWareLastFullScan);
	if (dashboard.mSpyWareLastFullScan == 0) {
		// return never if a scan was never completed.
		lastUpdateString = gDashboardBundle.getString('dashboardSpyScanFullScanLastNeverRun');
		document.getElementById('sdSpyWatchLastFullScan').setAttribute('value', lastUpdateString);
		dashboard.debug(lastUpdateString);
	} else {
		document.getElementById('sdSpyWatchLastFullScan').setAttribute('value', GetLastFullScanString());				
	}
	
	document.getElementById('sdSpyWatchProtectionStatus').setAttribute('value', spywatchMessage);

	// set black list last updated string
	if (dashboard.mSpywareLastScan != 0)
		lastUpdateString = GetLastBlackListLastUpdateString();

	document.getElementById('sdSpyWatchLastUpdate').setAttribute('value', lastUpdateString);
	
	// set the spywatch active scan pref
	var activeScanStatus;
	if (dashboard.mSpyWatchActiveScanOn) {
		activeScanStatus = "On"
	} else {
		activeScanStatus = "Off"
	}
	document.getElementById('sdSpyWatchDownloadScanDesc').setAttribute('value', activeScanStatus);
} // END SetSpywatchPanelUI

function GetLastBlackListLastUpdateString() {
			var lastUpdateHours = Math.floor(dashboard.mLastSilentUpdate / 60);
			var lastUpdateDays = Math.floor(lastUpdateHours / 24);
			if (lastUpdateDays > 0) {
				if (lastUpdateDays > 1)
					lastUpdateString = lastUpdateDays + " " + gDashboardBundle.getString('dashboardDaysAgo');
				else
					lastUpdateString = "Yesterday";
			}	else if (lastUpdateHours > 0) {
				if (lastUpdateHours > 1)
					lastUpdateString = lastUpdateHours + " " + gDashboardBundle.getString('dashboardHoursAgo');
				else
					lastUpdateString = lastUpdateHours + " Hour Ago";
			} else {
				if (dashboard.mLastSilentUpdate > 1)
					lastUpdateString = dashboard.mLastSilentUpdate  + " " + gDashboardBundle.getString('dashboardMinutesAgo');
				else
					lastUpdateString = dashboard.mLastSilentUpdate  + " " + ' Minute Ago';
			}
			
			return lastUpdateString;
	}
	
function GetLastFullScanString() {		
	var thisNow = Math.floor(dashboard.GetNowInSeconds());
  var lastFullScanTimeDiff = Math.floor((thisNow - dashboard.mSpyWareLastFullScan)/60);
	
	var lastUpdateHours = Math.floor(lastFullScanTimeDiff  / 60);
	var lastUpdateDays = Math.floor(lastUpdateHours / 24);
	if (lastUpdateDays > 0) {
		if (lastUpdateDays > 1)
			lastUpdateString = lastUpdateDays + " " + gDashboardBundle.getString('dashboardDaysAgo');
		else
			lastUpdateString = "Yesterday";
	}	else if (lastUpdateHours > 0) {
		if (lastUpdateHours > 1)
			lastUpdateString = lastUpdateHours + " " + gDashboardBundle.getString('dashboardHoursAgo');
		else
			lastUpdateString = lastUpdateHours + " Hour Ago";
	} else {
		if (lastFullScanTimeDiff > 1)
			lastUpdateString = lastFullScanTimeDiff  + " " + gDashboardBundle.getString('dashboardMinutesAgo');
		else
			lastUpdateString = lastFullScanTimeDiff  + " " + ' Minute Ago';
	}
	
	return lastUpdateString;
}

function SetCurrentSiteStatusPanelUI(sc) {
	
			var currentURI = gBrowser.currentURI;	
			var sdCurrenSiteStatusStatus = document.getElementById('currentSiteStatus');
				
			// set the status in the current site status panel
			sdCurrenSiteStatusStatus.setAttribute('status', dashboard.mCurrentSiteStatus);	
			// set the browser level on the current site status panel
			sdCurrenSiteStatusStatus.setAttribute('browserSetting', dashboard.mBrowserLevel);					
			document.getElementById('currentSiteStatusTrustSetterDesc').setAttribute('value', gDashboardBundle.getString('dashboardCurrSiteSettingsSetterUser'));	
			
			switch(dashboard.mCurrentSiteStatus) {
				case "disabled" :
					document.getElementById('currentSiteStatusDescription').setAttribute('value', 'Disabled');
					document.getElementById('currentSiteStatusSiteVerificationDescription').setAttribute('value','Trust Ratings are Disabled');
					document.getElementById('partnerPrefixDesc').removeAttribute('value');
					break;
				
				
				case "verified":
					document.getElementById('currentSiteStatusDescription').setAttribute('value', gDashboardBundle.getString('dashboardVerified'));
					document.getElementById('currentSiteStatusSiteVerificationDescription').setAttribute('value', gDashboardBundle.getString('dashboardSiteSecurityVerified'));
					document.getElementById('partnerPrefixDesc').setAttribute('value', gDashboardBundle.getString('dashboardVerifiedBy'));
					
					AddPartnerIconsToContainer('sdSitePartnersContainer', sc.SC_TRUST_WHITELIST_IDX);				
					break;
					
				case "warning":
					document.getElementById('currentSiteStatusDescription').setAttribute('value', gDashboardBundle.getString('dashboardUnVerified'));
					document.getElementById('currentSiteStatusSiteVerificationDescription').setAttribute('value', gDashboardBundle.getString('dashboardUnableToVerifySite'));
					document.getElementById('partnerPrefixDesc').setAttribute('value', gDashboardBundle.getString('dashboardNotKnownByTrustPartners'));
					break;
				
				case "critical":
					// site controls flagged this as warning, now determine what kind of threat it is
					// either have phishing, spyware or both warnings. warnings are delimited by a ','
					// so break it to an array
								
					var threatArray = dashboard.mCurrentSiteWarningType.split(',');
					if (!threatArray)
						break;
					
					document.getElementById('currentSiteStatusDescription').setAttribute('value', gDashboardBundle.getString('dashboardWarning'));
					document.getElementById('partnerPrefixDesc').setAttribute('value', gDashboardBundle.getString('dashboardBlacklistedBy'));		
					// only one threat for this site
					if (threatArray.length == 1) {		
						if (threatArray[0] == "phishing") {
							
							// set the id threat in the current site status panel
							document.getElementById('currentSiteStatusSiteVerificationDescription').setAttribute('value', gDashboardBundle.getString('dashboardKnownIDTheft'));
							AddPartnerIconsToContainer('sdSitePartnersContainer', sc.SC_TRUST_PHISHLIST_IDX);	
						
						} else if (threatArray[0] == "spyware") {
								// set current site status panel to display this warning
								// flag the current site status panel
								document.getElementById('partnerPrefixDesc').setAttribute('value', gDashboardBundle.getString('dashboardBlacklistedBy'));
								document.getElementById('spywatchPartnerPrefixDesc').setAttribute('value', gDashboardBundle.getString('dashboardBlacklistedBy'));
								document.getElementById('currentSiteStatusSiteVerificationDescription').setAttribute('value', gDashboardBundle.getString('dashboardKnownSpyware'));	
								AddPartnerIconsToContainer('sdSitePartnersContainer', sc.SC_TRUST_SPYLIST_IDX);	
						}
					} else if (threatArray.length > 1) {
						document.getElementById('sdIdentityProtectionStatus').setAttribute('value', gDashboardBundle.getString('dashboardKnownSpywarePhish'));	
						document.getElementById('currentSiteStatusSiteVerificationDescription').setAttribute('value', gDashboardBundle.getString('dashboardKnownSpywarePhish'));	
					}
					break;
			}	// end trust level switch	
			
			
			// start browser level switch
			switch (dashboard.mBrowserLevel) {	
				case "Low":
					document.getElementById('currentSiteStatusSiteUserTrustDesc').setAttribute('value', 'I Trust This Site');			
					// if there is no trust partners for this url, and the security level, is low it must be set by user
					var trustListArray = GetTrustListArray();
					if (trustListArray[0] == null )
						document.getElementById('currentSiteStatusTrustSetterDesc').setAttribute('value', '(Set Manually by User)');
					else
						document.getElementById('currentSiteStatusTrustSetterDesc').setAttribute('value', '(Set Automatically by Trust Advisor)');				
				break;
				
				case "Medium":
					document.getElementById('currentSiteStatusSiteUserTrustDesc').setAttribute('value', "I'm Not Sure");
					if (dashboard.mCurrentSiteStatus == "warning")
						document.getElementById('currentSiteStatusTrustSetterDesc').setAttribute('value', '(Set Automatically by Trust Advisor)');
					else
						document.getElementById('currentSiteStatusTrustSetterDesc').setAttribute('value', '(Set Manually By User)');
				break;
				
				case "High":
					document.getElementById('currentSiteStatusSiteUserTrustDesc').setAttribute('value', "I Don't Trust This Site");
					if (dashboard.mCurrentSiteStatus == "critical")
						document.getElementById('currentSiteStatusTrustSetterDesc').setAttribute('value', '(Set Automatically by Trust Advisor)');
					else
						document.getElementById('currentSiteStatusTrustSetterDesc').setAttribute('value', '(Set Manually By User)');		
				break;
				
				case "Custom":
					document.getElementById('currentSiteStatusSiteUserTrustDesc').setAttribute('value', 'Custom Settings');				
				break;
				
				default: 
					document.getElementById('currentSiteStatusSiteUserTrustDesc').setAttribute('value', '');						
		}
		
		// set the URL for the title of the current site status panel
		var host = sitecontrols.getHostStringFromURL(currentURI.spec);
		if (host) {
			document.getElementById('currentSiteStatusUrl').setAttribute('value', host);
		} else {
			document.getElementById('currentSiteStatusUrl').setAttribute('value', 'Netscape Trust Advisor');
		}
				
} // END SetCurrentSiteStatusPanelUI

function AddPartnerIconsToContainer(aContainerId, aCode) {
	// set the providers who verified this site in the current site status panel
	
	var container = document.getElementById(aContainerId);
	if (!container)
		return;
		
	var whiteListArray = GetTrustListArray(aCode);
	var whiteListURLArray = GetTrustListURLArray(aCode);
	var whiteListIconArray = GetTrustListIconArray(aCode);
	var iconElem;

	for(var i = 0; i < whiteListArray.length; i++) {
		iconElem = document.createElement("image");
		iconElem.setAttribute("src", whiteListIconArray[i]);
		tmpURL = "LoadTrustPartnersTab('" + whiteListURLArray[i] + "');";
		iconElem.setAttribute("onclick", tmpURL);
		container.appendChild(iconElem);
	}		
}	

function GetTrustListArray(aCode) {
	var currentURI = gBrowser.currentURI;
	var sc = sitecontrols.SCSVC;
	var site = sc.getResourceForURI(currentURI.spec);
	
	// get partner information from site controls service
	var whiteListCode = sc.getSiteTrustLevelDetail(currentURI.spec, aCode);
	var whiteListStr = sc.getSiteTrustProviderName(whiteListCode);
	var whiteListArray = whiteListStr.split('|');
	return whiteListArray;
}

function GetTrustListURLArray(aCode) {
	var currentURI = gBrowser.currentURI;
	var sc = sitecontrols.SCSVC;
	var site = sc.getResourceForURI(currentURI.spec);
	
	// get partner information from site controls service
	var whiteListCode = sc.getSiteTrustLevelDetail(currentURI.spec, aCode);
	var whiteListURLStr = sc.getSiteTrustProviderURL(whiteListCode);
	var whiteListURLArray = whiteListURLStr.split('|');
	return whiteListURLArray;
}

function GetTrustListIconArray(aCode) {
	var currentURI = gBrowser.currentURI;
	var sc = sitecontrols.SCSVC;
	var site = sc.getResourceForURI(currentURI.spec);
	
	// get partner information from site controls service
	var whiteListCode = sc.getSiteTrustLevelDetail(currentURI.spec, aCode);
	var whiteListIconStr = sc.getSiteTrustProviderIcon(whiteListCode);
	var whiteListIconArray = whiteListIconStr.split('|');
	return whiteListIconArray;
}	


function SetPopupBlockingPanelUI() {
	if (dashboard.mPopupBlocking) {
		document.getElementById('sdPopupBlockingEnabledDescription').setAttribute('value', 'Enabled');
		document.getElementById('sdPopupBlocking').removeAttribute("status");
		document.getElementById('sdPopupStatusDesc').setAttribute("value", "Popup Blocking Enabled");
	} else {
		document.getElementById('sdPopupBlockingEnabledDescription').setAttribute('value', 'Disabled');
		document.getElementById('sdPopupBlocking').setAttribute("status", "warning");	
		document.getElementById('sdPopupStatusDesc').setAttribute("value", "Popup Blocking Disabled");
	}

	// Update the UI with the master popup blocking settings from the dashboard object						
	if (dashboard.mMasterPopupVerified == "false") {
		document.getElementById('sdPopupTrustedSitesDesc').setAttribute('value', 'Enabled');
	} else {
		document.getElementById('sdPopupTrustedSitesDesc').setAttribute('value', 'Disabled');
	}

	if (dashboard.mMasterPopupUnverified  == "false") {
		document.getElementById('sdPopupNotSureSitesDesc').setAttribute('value', 'Enabled');
	} else {
		document.getElementById('sdPopupNotSureSitesDesc').setAttribute('value', 'Disabled');
	}
	
	if (dashboard.mMasterPopupNotTrusted == "false") {
		document.getElementById('sdPopupNotTrustedSitesDesc').setAttribute('value', 'Enabled');
	} else {
		document.getElementById('sdPopupNotTrustedSitesDesc').setAttribute('value', 'Disabled');
	}	
}

function SetBrowserUpdatePanelUI() {
	
	var panelButton = document.getElementById('sdUpdateNowBtn');
	panelButton.hidden = true;
	
	var appVersion = gPrefService.getCharPref('app.version');
	if (gPrefService.prefHasUserValue('app.newest_version')) {
		var newestAppVersion = gPrefService.getCharPref('app.newest_version');
	}
	
	document.getElementById('sdBrowerUpdateBrowserVerDesc').setAttribute('value', appVersion);
	document.getElementById('sdBrowserUpdates').removeAttribute('status');
	
	// BC: Getting the 'newest' browser version and inserting it into the dashboard.
	if (dashboard.mNewestBrowserVersion == null || dashboard.mNewestBrowserVersion == '') {
		// 	Check if newestAppVersion is null, set to default
		if (newestAppVersion == null || newestAppVersion == '') {
			document.getElementById('sdBrowerUpdateNewestVer').setAttribute('value', appVersion);
		// Check if newestAppVersion is NOT null, or empty, then set the value to it
		} else if (newestAppVersion != null || newestAppVersion != '') {
			document.getElementById('sdBrowerUpdateNewestVer').setAttribute('value', newestAppVersion);
		// Check if dashboard version is null, set to default
		}	
	} else if (dashboard.mNewestBrowserVersion != null || dashboard.mNewestBrowserVersion != '') {
			document.getElementById('sdBrowerUpdateNewestVer').setAttribute('value', dashboard.mNewestBrowserVersion);	
	}
	
	var updatesAvailable = gPrefService.getBoolPref('app.update.updatesAvailable');
	var updateSeverity =  gPrefService.getIntPref('update.severity');
	var lastAppLastUpdated = gPrefService.getIntPref('app.update.lastUpdateDate');
	var updatesPerformed = gPrefService.getBoolPref('app.update.performed');
	
	var browserUpdatePanel = document.getElementById('sdBrowserUpdates');
	
	
	
	// no updates available
	if (dashboard.mUpdateAvailable == -1) {
		document.getElementById('sdBrowserAvailableDesc').setAttribute('value', 'Netscape 8 is Up To Date');
		document.getElementById('browserUpdatesEnabledDescription').setAttribute("value", "Up To Date");
		browserUpdatePanel.removeAttribute('status');
	} else if (updatesPerformed == false){
		// unhide the button
		panelButton.hidden = false;
		// the update is critical (i.e. a browser app update)						
		if (updateSeverity == nsIUpdateService.SEVERITY_HIGH) {
			// add critical update to threats queue
			threatsQueue.add(dashboard.kCriticalUpdate, "red");
			browserUpdatePanel.setAttribute('warningAutoExposed', true);
			browserUpdatePanel.setAttribute('status', 'critical');
			document.getElementById('browserUpdatesEnabledDescription').setAttribute("value", "Critical Update");
			var browserVersionAvailable = gPrefService.getCharPref('update.app.updateVersion');
			document.getElementById('sdBrowserAvailableDesc').setAttribute('value', 'Browser ' + browserVersionAvailable + ' Available');
		} 
		// an extension update
		else if (updateSeverity == nsIUpdateService.SEVERITY_MEDIUM) {
			// this is an extension, count number of extensions available		
			var num_extensions_available = gPrefService.getIntPref('extensions.update.count');
			if (num_extensions_available == 1) {
				document.getElementById('browserUpdatesEnabledDescription').setAttribute("value", "Update Available");	
			} else if (num_extensions_available > 1) {
				document.getElementById('browserUpdatesEnabledDescription').setAttribute("value", "Multiple Updates Available");
			}				
			browserUpdatePanel.removeAttribute('warningAutoExposed');
			browserUpdatePanel.setAttribute('status', 'update');
			document.getElementById('browserUpdatesEnabledDescription').setAttribute("value", "Extension Update");
			document.getElementById('sdBrowserAvailableDesc').setAttribute('value', 'Extension Update Available');
		}	
	} else {
		browserUpdatePanel.removeAttribute('warningAutoExposed');
	}
	
	if (dashboard.mLastAppUpdate == -1) {
			document.getElementById('sdBrowerUpdateLastUpdate').setAttribute('value', gDashboardBundle.getString('dashboardToday'));
		} else {
			var browserLastAppUpdate = Math.floor(dashboard.mLastAppUpdate / (ONE_DAY_IN_SECONDS));
			var timeUnit;
										
			// browser updated today
			if (browserLastAppUpdate < 1) {
				document.getElementById('sdBrowerUpdateLastUpdate').setAttribute('value', gDashboardBundle.getString('dashboardToday'));
			}	else if (browserLastAppUpdate > 0 && browserLastAppUpdate < 7) {
				if (browserLastAppUpdate == 1) {
					timeUnit = gDashboardBundle.getString('dashboardYesterday');
					browserLastAppUpdate = "";
				} else if (browserLastAppUpdate > 1) {
					timeUnit = gDashboardBundle.getString('dashboardDaysAgo');
				}
				document.getElementById('sdBrowerUpdateLastUpdate').setAttribute('value', browserLastAppUpdate + ' ' + timeUnit);					
			}			
			// updated between one day and one week ago and one month ago
			else if (browserLastAppUpdate > 6 && browserLastAppUpdate < 31) {
				timeUnit = " " + gDashboardBundle.getString('dashboardWeeks');
				var browserAppUpdateInWeeks = Math.floor(browserLastAppUpdate / 7);
				if (browserAppUpdateInWeeks == 1) {
					timeUnit = " " + gDashboardBundle.getString('dashboardWeek');
				}
				
				document.getElementById('sdBrowerUpdateLastUpdate').setAttribute('value', browserAppUpdateInWeeks + timeUnit + ' ' + gDashboardBundle.getString('dashboardAgo'));
			} else {
				// updated over a month ago
				timeUnit = gDashboardBundle.getString('dashboardMonthes');
				var browserAppUpdateInMonthes = Math.floor(browserLastAppUpdate / 30);
				if (browserAppUpdateInMonthes == 1) {
					timeUnit = gDashboardBundle.getString('dashboardMonth');
				}
				document.getElementById('sdBrowerUpdateLastUpdate').setAttribute('value', browserAppUpdateInMonthes + ' ' + timeUnit + ' ' +  gDashboardBundle.getString('dashboardAgo'));
			}
			
		}
}

function SetCurrentSiteRatingsPanelUI() {
	if (dashboard.mEngine == "Firefox") {
		document.getElementById('sdCurrSiteEngineImage').setAttribute('class', 'firefox-icon');
		document.getElementById('sdCurrentSiteSettings').removeAttribute('status');
		document.getElementById('currentSiteSettingsDescription').setAttribute('value', 'OK');
		document.getElementById('sdCurrSiteActiveX').setAttribute('value', 'Disabled');
		document.getElementById('scriptType').setAttribute('value', 'JavaScript');
		threatsQueue.remove(dashboard.kActiveXOn);
	}	else {
		document.getElementById('sdCurrSiteEngineImage').setAttribute('class', 'ie-icon');
		document.getElementById('scriptType').setAttribute('value', 'JavaScript/VBScript:');
		if (dashboard.mEnableActiveX == "Enabled") {
			document.getElementById('sdCurrentSiteSettings').setAttribute('status', 'warning');
			document.getElementById('currentSiteSettingsDescription').setAttribute('value', 'ActiveX On');
			threatsQueue.add(dashboard.kActiveXOn, "yellow");
		} else {
			document.getElementById('sdCurrentSiteSettings').removeAttribute('status');
			document.getElementById('currentSiteSettingsDescription').setAttribute('value', 'OK');
			threatsQueue.remove(dashboard.kActiveXOn);
		}
	}
	if (dashboard.mEngine != "Firefox")
		document.getElementById('sdCurrSiteActiveX').setAttribute('value', dashboard.mEnableActiveX);
		
	document.getElementById('sdCurrSiteRenderingEngine').setAttribute('value', dashboard.mEngine);
	document.getElementById('sdCurrSiteImages').setAttribute('value', dashboard.mAllowImages);
	document.getElementById('sdCurrSiteJava').setAttribute('value', dashboard.mEnableJava);
	document.getElementById('sdCurrSiteCookies').setAttribute('value', dashboard.mAllowCookies);
	document.getElementById('sdCurrSiteJavaScript').setAttribute('value', dashboard.mEnableJavaScript);
		
}

function GetNextSilentUpdateAttemptString() {	
		var lastSilentUpdateTime = gPref.getIntPref('silent.update.lastUpdateDate'); // stored in s
		var silentUpdateInterval = Math.floor(gPref.getIntPref('silent.update.interval')/1000); // in ms
		var nextSilentUpdateTime = lastSilentUpdateTime + silentUpdateInterval; //
				
		// get update interval in seconds
		var updateInterval = Math.floor(silentUpdateInterval/(1000));
	
		// already in seconds
		var lastSilentUpdate = gPref.getIntPref('silent.update.lastUpdateDate');
		
		// next update time from now in seconds
		var diff = lastSilentUpdateTime + silentUpdateInterval - dashboard.GetNowInSeconds();
		
		var diffInMinutes = Math.floor(diff/60);
		var diffInHours = Math.floor(diffInMinutes/60);
		var diffInDays = Math.floor(diffInHours/24);
					
		var textPrefix = gDashboardBundle.getString('dashboardTryingAgain');
		var timeUnits;
		var quantity;
		
		if (diffInDays > 0) {
			timeUnits = gDashboardBundle.getString('dashboardDays');
			quantity = diffInDays;
		} else if (diffInHours > 0) {
			timeUnits = gDashboardBundle.getString('dashboardHours');
			quantity = diffInHours;
		} else {
			timeUnits = gDashboardBundle.getString('dashboardMinutes');
			quantity = diffInMinutes;
		}
		
		return gDashboardBundle.getString('dashboardTryingAgain') + " " + quantity + " " + timeUnits;
}

function ToggleAutoexposeCheckboxVisibility() {
	var chkbox = document.getElementById('sdChkAutoShouldAutoExpose');
	if (dashboard.mAutoExposeProblem == true) {
		chkbox.setAttribute('checked','true');
		chkbox.hidden = false;
	} else {
		chkbox.hidden = true;
	}
}

function ToggleDailyAutoexposeCheckboxVisibility() {
	var chkbox = document.getElementById('sdChkAutoShouldAutoExposeDaily');
	if (dashboard.mAutoExposeDaily == true) {
		chkbox.setAttribute('checked','true');
		chkbox.hidden = false;
	} else {
		chkbox.hidden = true;
	}
}


function RefreshPosition() {
	if (window.opener.windowState == window.opener.STATE_MINIMIZED) {
		dashboard.mDashboardWindow = null;
		dashboard.mDashboardWindowLoaded = false;			
		window.close();
		return;
	}
	
	RepositionDashboard();
	setTimeout('RefreshPosition()', 50);
}

function LoadTrustPartnersTab(aURL) {
	var trustTab = gBrowser.addTabAt(aURL);
	if (!gPrefService.getBoolPref("browser.tabs.loadInBackground"))
		gBrowser.selectedTab = trustTab;
}

function SetBalloonHelpPref() {	
	if (balloonhelp) {
		var enabled;
		try  {
			enabled = balloonhelp.GetBalloonHelpPreference();
		} catch (ex) {
			balloonhelp.debug(ex);
		}	
		var dbBalloonHelpButton = document.getElementById('dbBalloonButton');
		if (dbBalloonHelpButton)
			dbBalloonHelpButton.setAttribute('showballoon', (enabled ? "true" : "false"));
	}
}

function ToggleDashboardBalloonHelp(aValue) {	
	var dbBalloonHelpButton = document.getElementById('dbBalloonButton');
	if (dbBalloonHelpButton)
		dbBalloonHelpButton.setAttribute('showballoon', (aValue ? "true" : "false"));
}

dashboard.mDashboardWindowLoaded = true;
